Imports System.Text
Imports System.Threading.Tasks
Imports TicketSystem.ServiceContract
Imports ServiceStack.ServiceClient.Web

Namespace ServiceStackClient
	Friend Class Program
		Shared Sub Main(ByVal args() As String)
			Console.Title = "ServiceStack Console Client"

			Using client = New Soap11ServiceClient("http://localhost:30542")
				Dim queuedTickets As List(Of Ticket) = client.Send(Of List(Of Ticket))(New GetAllTicketsInQueueRequest)
				If queuedTickets IsNot Nothing Then
					For Each ticket As Ticket In queuedTickets
						PrintTicket(ticket)
					Next ticket
				End If
			End Using

			Console.ReadKey()
		End Sub

		Private Shared Sub PrintTicket(ByVal ticket As Ticket)
			Console.WriteLine("Ticket ID: {0}", ticket.TicketId)
			Console.WriteLine(vbTab & "Table: {0}", ticket.TableNumber)
			Console.WriteLine(vbTab & "Orders: ")

			For Each order In ticket.Orders
				Console.WriteLine(vbTab & vbTab & "{0}: {1}-{2}", order.Category, order.MenuId, order.ItemDescription)
			Next order
		End Sub
	End Class
End Namespace
