Imports TicketSystem.ServiceContract
Imports ServiceStackServer.Translators
Imports ServiceStack.ServiceInterface

Namespace ServiceStackServer
	Public Class TicketService
		Inherits Service
		Implements ITicketService

		Private Shared ReadOnly _ticketProcessor As New TicketSystem.TicketProcessor.TicketProcessor

		Public Function Any(ByVal request As GetAllTicketsInQueueRequest) As List(Of Ticket) Implements ITicketService.Any
			Return _ticketProcessor.GetTicketsInQueue.Select(AddressOf TicketTranslator.TranslateTicket).ToList
		End Function

		Public Sub Any(ByVal request As QueueTicketRequest) Implements ITicketService.Any
			_ticketProcessor.QueueTicket(TicketTranslator.TranslateTicket(request.Ticket))
		End Sub

		Public Function Any(ByVal request As PullTicketRequest) As Ticket Implements ITicketService.Any
			Dim nextTicket As TicketSystem.TicketProcessor.Ticket = _ticketProcessor.PullTicket

			If nextTicket IsNot Nothing Then
				Return TicketTranslator.TranslateTicket(nextTicket)
			End If

			Return Nothing
		End Function
	End Class
End Namespace
