Namespace ServiceStackServer.Translators
	Public NotInheritable Class TicketTranslator
		Private Sub New()
		End Sub

		Public Shared Function TranslateTicket(ByVal input As TicketSystem.TicketProcessor.Ticket) As TicketSystem.ServiceContract.Ticket
			Return New TicketSystem.ServiceContract.Ticket With {.Orders = input.Orders.Select(AddressOf TranslateOrder).ToList, .ServerId = input.ServerId, .TableNumber = input.TableNumber, .Timestamp = input.Timestamp, .TicketId = input.TicketId}
		End Function

		Public Shared Function TranslateTicket(ByVal input As TicketSystem.ServiceContract.Ticket) As TicketSystem.TicketProcessor.Ticket
			Return New TicketSystem.TicketProcessor.Ticket With {.Orders = input.Orders.Select(AddressOf TranslateOrder).ToList, .ServerId = input.ServerId, .TableNumber = input.TableNumber, .Timestamp = input.Timestamp, .TicketId = input.TicketId}
		End Function

		Public Shared Function TranslateOrder(ByVal input As TicketSystem.TicketProcessor.Order) As TicketSystem.ServiceContract.Order
			Return New TicketSystem.ServiceContract.Order With {.Category = TranslateMenuCategory(input.Category), .ItemDescription = input.ItemDescription, .MenuId = input.MenuId}
		End Function

		Public Shared Function TranslateOrder(ByVal input As TicketSystem.ServiceContract.Order) As TicketSystem.TicketProcessor.Order
			Return New TicketSystem.TicketProcessor.Order With {.Category = TranslateMenuCategory(input.Category), .ItemDescription = input.ItemDescription, .MenuId = input.MenuId}
		End Function

		Public Shared Function TranslateMenuCategory(ByVal input As TicketSystem.TicketProcessor.MenuCategory) As TicketSystem.ServiceContract.MenuCategory
			Select Case input
				Case TicketSystem.TicketProcessor.MenuCategory.Appetizer
					Return TicketSystem.ServiceContract.MenuCategory.Appetizer

				Case TicketSystem.TicketProcessor.MenuCategory.Dessert
					Return TicketSystem.ServiceContract.MenuCategory.Dessert

				Case TicketSystem.TicketProcessor.MenuCategory.MainCourse
					Return TicketSystem.ServiceContract.MenuCategory.MainCourse

				Case Else
					Return TicketSystem.ServiceContract.MenuCategory.Others
			End Select
		End Function

		Public Shared Function TranslateMenuCategory(ByVal input As TicketSystem.ServiceContract.MenuCategory) As TicketSystem.TicketProcessor.MenuCategory
			Select Case input
				Case TicketSystem.ServiceContract.MenuCategory.Appetizer
					Return TicketSystem.TicketProcessor.MenuCategory.Appetizer

				Case TicketSystem.ServiceContract.MenuCategory.Dessert
					Return TicketSystem.TicketProcessor.MenuCategory.Dessert

				Case TicketSystem.ServiceContract.MenuCategory.MainCourse
					Return TicketSystem.TicketProcessor.MenuCategory.MainCourse

				Case Else
					Return TicketSystem.TicketProcessor.MenuCategory.Others
			End Select
		End Function
	End Class
End Namespace
