Imports System.Text
Imports System.Threading.Tasks

Namespace TicketSystem.TicketProcessor
	Public Class Ticket
		Public Property TicketId As Integer

		Public Property TableNumber As Integer

		Public Property ServerId As Integer

		Public Property Orders As List(Of Order)

		Public Property Timestamp As Date
	End Class

	Public Class Order
		Public Property Category As MenuCategory

		Public Property MenuId As Integer

		Public Property ItemDescription As String
	End Class

	Public Enum MenuCategory
		Others = -1

		Appetizer = 0

		MainCourse = 1

		Dessert = 2
	End Enum

	Public Class TicketProcessor
		Private ReadOnly _queuedTickets As New Queue(Of Ticket)

		Public Sub New()
			Dim apps As New List(Of String) From {"Mac and Cheese", "Pretzels", "Sweet Potato Fries"}

			Dim mainCourses As New List(Of String) From {"Steak Burger", "Spaghetti with Meatballs", "Beef Stew"}

			Dim desserts As New List(Of String) From {"Keylime Pie", "Chocolate Cake", "Ice Cream"}

			Dim menuId As Integer = 0

			'Add some sample data
			For i  = 0 To 2
'ORIGINAL LINE: _queuedTickets.Enqueue(New Ticket { ServerId = i + 1, TableNumber = i + 1, TicketId = i + 1, Timestamp = DateTime.Now, Orders = New List(Of Order) { New Order { Category = MenuCategory.Appetizer, MenuId = ++menuId, ItemDescription = appsi }, New Order { Category = MenuCategory.MainCourse, MenuId = ++menuId, ItemDescription = mainCoursesi }, New Order { Category = MenuCategory.Dessert, MenuId = ++menuId, ItemDescription = dessertsi } } });
				_queuedTickets.Enqueue(New Ticket With {.ServerId = i + 1, .TableNumber = i + 1, .TicketId = i + 1, .Timestamp = Date.Now, .Orders = New List(Of Order) From {
					New Order With {.Category = MenuCategory.Appetizer, .MenuId = ++menuId, .ItemDescription = apps(i)},
					New Order With {.Category = MenuCategory.MainCourse, .MenuId = ++menuId, .ItemDescription = mainCourses(i)},
					New Order With {.Category = MenuCategory.Dessert, .MenuId = ++menuId, .ItemDescription = desserts(i)}}})
			Next i
		End Sub

		Public Function GetTicketsInQueue() As List(Of Ticket)
			Return _queuedTickets.ToList
		End Function

		Public Sub QueueTicket(ByVal ticket As Ticket)
			_queuedTickets.Enqueue(ticket)
		End Sub

		Public Function PullTicket() As Ticket
			Return _queuedTickets.Dequeue
		End Function
	End Class
End Namespace
