Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.ServiceModel.Web
Imports System.Text
Imports TicketSystem.ServiceContract
Imports WcfServer.Translators

Namespace WcfServer
	Public Class TicketService
		Implements ITicketService

		Private Shared ReadOnly _ticketProcessor As New TicketSystem.TicketProcessor.TicketProcessor

        Public Function GetAllTicketsInQueue() As List(Of Ticket) Implements ITicketService.GetAllTicketsInQueue
            Return _ticketProcessor.GetTicketsInQueue.Select(AddressOf TicketTranslator.TranslateTicket).ToList
        End Function

        Public Sub QueueTicket(ByVal ticket As Ticket) Implements ITicketService.QueueTicket
            _ticketProcessor.QueueTicket(TicketTranslator.TranslateTicket(ticket))
        End Sub

        Public Function PullTicket() As Ticket Implements ITicketService.PullTicket
            Dim nextTicket As TicketSystem.TicketProcessor.Ticket = _ticketProcessor.PullTicket

            If nextTicket IsNot Nothing Then
                Return TicketTranslator.TranslateTicket(nextTicket)
            End If

            Return Nothing
        End Function
	End Class
End Namespace
