Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.Text
Imports TicketSystem.ServiceContract
Imports WcfServer.Translators

Namespace WcfServer
	Public Class TicketServiceAlt
		Implements ITicketServiceAlt

		Private Shared ReadOnly _ticketProcessor As New TicketSystem.TicketProcessor.TicketProcessor

        Public Function GetAllTicketsInQueue(ByVal request As GetAllTicketsInQueueRequest) As List(Of Ticket) Implements ITicketServiceAlt.GetAllTicketsInQueue
            Return _ticketProcessor.GetTicketsInQueue.Select(AddressOf TicketTranslator.TranslateTicket).ToList
        End Function

        Public Sub QueueTicket(ByVal request As QueueTicketRequest) Implements ITicketServiceAlt.QueueTicket
            _ticketProcessor.QueueTicket(TicketTranslator.TranslateTicket(request.Ticket))
        End Sub

        Public Function PullTicket(ByVal request As PullTicketRequest) As Ticket Implements ITicketServiceAlt.PullTicket
            Dim nextTicket As TicketSystem.TicketProcessor.Ticket = _ticketProcessor.PullTicket

            If nextTicket IsNot Nothing Then
                Return TicketTranslator.TranslateTicket(nextTicket)
            End If

            Return Nothing
        End Function
	End Class
End Namespace
