Imports System.Runtime.Serialization
Imports System.ServiceModel
Imports System.Text

Namespace TicketSystem.ServiceContract
	<ServiceContract>
	Public Interface ITicketService
		<OperationContract>
		Function GetAllTicketsInQueue() As List(Of Ticket)
		<OperationContract>
		Sub QueueTicket(ByVal ticket As Ticket)
		<OperationContract>
		Function PullTicket() As Ticket
	End Interface

	<DataContract>
	Public Class Ticket
		<DataMember>
		Public Property TicketId As Integer

		<DataMember>
		Public Property TableNumber As Integer

		<DataMember>
		Public Property ServerId As Integer

		<DataMember>
		Public Property Orders As List(Of Order)

		<DataMember>
		Public Property Timestamp As Date
	End Class

	<DataContract>
	Public Class Order
		<DataMember>
		Public Property Category As MenuCategory

		<DataMember>
		Public Property MenuId As Integer

		<DataMember>
		Public Property ItemDescription As String
	End Class

	<DataContract>
	Public Enum MenuCategory
		<EnumMember>
		Others = -1

		<EnumMember>
		Appetizer = 0

		<EnumMember>
		MainCourse = 1

		<EnumMember>
		Dessert = 2
	End Enum
End Namespace
