Imports System.Text
Imports System.Threading.Tasks
Imports WcfClient.TicketService

Namespace WcfClient
	Friend Class Program
		Shared Sub Main(ByVal args() As String)
			Console.Title = "WCF Console Client"

			Using client As New TicketServiceClient
				Dim queuedTickets() As Ticket = client.GetAllTicketsInQueue

				For Each ticket As Ticket In queuedTickets
					PrintTicket(ticket)
				Next ticket
			End Using

			Console.ReadKey()
		End Sub

		Private Shared Sub PrintTicket(ByVal ticket As Ticket)
			Console.WriteLine("Ticket ID: {0}", ticket.TicketId)
			Console.WriteLine(vbTab & "Table: {0}", ticket.TableNumber)
			Console.WriteLine(vbTab & "Orders: ")

			For Each order In ticket.Orders
				Console.WriteLine(vbTab & vbTab & "{0}: {1}-{2}", order.Category, order.MenuId, order.ItemDescription)
			Next order
		End Sub
	End Class
End Namespace
